/*
 * MyGantt JavaScript Library v1.2
 *
 * Copyright 2010, Speed Star
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://www.speed-star1.com
 *
 * Includes jquery-1.4.2.min.js
 * http://sizzlejs.com/
 * Copyright 2010, The Dojo Foundation
 * Released under the MIT, BSD, and GPL Licenses.
 *
 * Includes Sizzle.js
 * http://sizzlejs.com/
 * Copyright 2010, The Dojo Foundation
 * Released under the MIT, BSD, and GPL Licenses.
 *
 * Date: Wed Feb 17 03:54:32 2010 -0900
 */

var mygantt;

if (!mygantt) mygantt = {};

// 年
mygantt.yearJpn  = "/";

// 月
mygantt.monthJpn = "";

// チャート描画域のHTMLオブジェクト
mygantt.chartAreaObj = null;

// チャート描画域のid
mygantt.chartAreaId  = "";

// チャート情報の格納用
mygantt.chartInfo    = {};

// レコード情報の格納用
mygantt.recordInfo   = [];

// チャートデータ
mygantt.chartData    = [];

// チャート表示用tableオブジェクトの保持用
mygantt.taskTableObj = null;

// チャート表示用のtbodyオブジェクトの保持用
mygantt.taskTbodyObj = null;

// チャート表示する開始日のDateオブジェクト
mygantt.calSdateObj = null;

// チャート表示対象の日付格納用
mygantt.dateAll = [];

// 未入力時の表示
mygantt.blankMark = "<i>blank</i>";

// 現在選択されている行番号
mygantt.selectIdx = -1;

// コンテキストメニューオブジェクトの保持用
mygantt.contextMenu = null;

// コンテキストメニューの内容(nullはセパレータ)
mygantt.contextMenuInfo = [["上に移動","mygantt.recordUp()"]
                          ,["下に移動","mygantt.recordDown()"]
                          ,null
                          ,["上に追加","mygantt.recordAddOver()"]
                          ,["下に追加","mygantt.recordAddUnder()"]
                          ,["削除","mygantt.recordDel()"]
                          ];
// 祝日の定義格納用
mygantt.holidays   = [];
mygantt.holidayMap = {};

// 曜日の定義
mygantt.youbiText = [];

mygantt.mObj  = null;
mygantt.mPreX = null;
mygantt.mObjSdateType = null;
mygantt.mObjSdateType = null;
mygantt.rObj = null;
mygantt.rPreX = 0;

mygantt.objChgDataBox = null;
mygantt.objChgData    = null;

// 日付の表示形式
mygantt.dateFormat = "yyyy/mm/dd";

/**
 * チャート情報の初期化
 */
mygantt.initChart = function(chartAreaId, chartInfo, recordInfo, chartData){

	mygantt.chartInfo    = chartInfo;
	mygantt.recordInfo   = recordInfo;
	mygantt.chartData    = chartData;
	mygantt.dateAll      = mygantt.getCalDates();

	window.document.onmousemove   = mygantt.mMove;
	window.document.onclick       = function() { if (mygantt.contextMenu != null) mygantt.contextMenu.style.display = "none"; }

	mygantt.chartAreaId  = chartAreaId;
	mygantt.chartAreaObj = document.getElementById(chartAreaId);

	// テーブル作成
	mygantt.taskTableObj = document.createElement("table");
	mygantt.taskTableObj.className = "mygantt_table";
	mygantt.taskTbodyObj = document.createElement("tbody");

	// テーブルをチャート描画域に追加
	mygantt.taskTableObj.appendChild(mygantt.taskTbodyObj);
	mygantt.chartAreaObj.appendChild(mygantt.taskTableObj);
};


/**
 * ガントチャートの出力
 */
mygantt.printChart = function(){

	if (mygantt.holidays.length > 0 ) {
		var holidaysMap = {};
		for (i = 0; i < mygantt.holidays.length; i++) {
			holidaysMap[mygantt.holidays[i]] = mygantt.holidays[i];
		}
		mygantt.holidayMap = holidaysMap;
	}

	// データ変更用入力BOXの追加
	mygantt.addChgDataBox();

	// コンテキストメニューの追加
	mygantt.addContextMenu();

	// ヘッダ作成
	mygantt.addHeader();

	// 明細作成
	mygantt.addDetail();
};

/**
 * ガントチャートを再出力する
 */
mygantt.rewriteChart = function(){

	// 削除
	while(mygantt.chartAreaObj.firstChild){
		mygantt.chartAreaObj.removeChild(mygantt.chartAreaObj.firstChild);
	}

	// テーブル作成
	mygantt.taskTableObj = document.createElement("table");
	mygantt.taskTableObj.className = "mygantt_table";
	mygantt.taskTbodyObj = document.createElement("tbody");

	// テーブルをチャート描画域に追加
	mygantt.taskTableObj.appendChild(mygantt.taskTbodyObj);
	mygantt.chartAreaObj.appendChild(mygantt.taskTableObj);

	// 再出力
	mygantt.printChart();
};

/**
 * 前月のチャートを表示する
 */
mygantt.lastMonth = function() {
	var yyyy1    = parseInt(mygantt.chartInfo["sdate"].substring(0,4),10);
	var mm1      = parseInt(mygantt.chartInfo["sdate"].substring(4,6),10);
	var dd1      = mygantt.chartInfo["sdate"].substring(6,8);
	var dateObj1 = mygantt.addMonth(yyyy1,mm1,dd1, -1);
	mygantt.chartInfo["sdate"] = mygantt.getDateText(dateObj1);

	var yyyy2    = parseInt(mygantt.chartInfo["edate"].substring(0,4),10);
	var mm2      = parseInt(mygantt.chartInfo["edate"].substring(4,6),10);
	var dd2      = mygantt.chartInfo["edate"].substring(6,8);
	var dateObj2 = mygantt.addMonth(yyyy2,mm2,dd2, -1);
	mygantt.chartInfo["edate"] = mygantt.getDateText(dateObj2);

	mygantt.dateAll      = mygantt.getCalDates();
	mygantt.calSdateObj  = null;
	mygantt.rewriteChart();
};

/**
 * 次月のチャートを表示する
 */
mygantt.nextMonth = function() {
	var yyyy1    = parseInt(mygantt.chartInfo["sdate"].substring(0,4),10);
	var mm1      = parseInt(mygantt.chartInfo["sdate"].substring(4,6),10);
	var dd1      = mygantt.chartInfo["sdate"].substring(6,8);
	var dateObj1 = mygantt.addMonth(yyyy1,mm1,dd1, 1);
	mygantt.chartInfo["sdate"] = mygantt.getDateText(dateObj1);

	var yyyy2    = parseInt(mygantt.chartInfo["edate"].substring(0,4),10);
	var mm2      = parseInt(mygantt.chartInfo["edate"].substring(4,6),10);
	var dd2      = mygantt.chartInfo["edate"].substring(6,8);
	var dateObj2 = mygantt.addMonth(yyyy2,mm2,dd2, 1);
	mygantt.chartInfo["edate"] = mygantt.getDateText(dateObj2);

	mygantt.dateAll      = mygantt.getCalDates();
	mygantt.calSdateObj  = null;
	mygantt.rewriteChart();
};

/**
 * 前週のチャートを表示する
 */
mygantt.lastWeek = function() {

	var yyyy1    = parseInt(mygantt.chartInfo["sdate"].substring(0,4),10);
	var mm1      = parseInt(mygantt.chartInfo["sdate"].substring(4,6),10);
	var dd1      = mygantt.chartInfo["sdate"].substring(6,8);
	var dateObj1 = mygantt.addDay(yyyy1,mm1,dd1, -7);
	mygantt.chartInfo["sdate"] = mygantt.getDateText(dateObj1);

	var yyyy2    = parseInt(mygantt.chartInfo["edate"].substring(0,4),10);
	var mm2      = parseInt(mygantt.chartInfo["edate"].substring(4,6),10);
	var dd2      = mygantt.chartInfo["edate"].substring(6,8);
	var dateObj2 = mygantt.addDay(yyyy2,mm2,dd2, -7);
	mygantt.chartInfo["edate"] = mygantt.getDateText(dateObj2);

	mygantt.dateAll      = mygantt.getCalDates();
	mygantt.calSdateObj  = null;
	mygantt.rewriteChart();
};


/**
 * 次週のチャートを表示する
 */
mygantt.nextWeek = function() {

	var yyyy1    = parseInt(mygantt.chartInfo["sdate"].substring(0,4),10);
	var mm1      = parseInt(mygantt.chartInfo["sdate"].substring(4,6),10);
	var dd1      = mygantt.chartInfo["sdate"].substring(6,8);
	var dateObj1 = mygantt.addDay(yyyy1,mm1,dd1, 7);
	mygantt.chartInfo["sdate"] = mygantt.getDateText(dateObj1);

	var yyyy2    = parseInt(mygantt.chartInfo["edate"].substring(0,4),10);
	var mm2      = parseInt(mygantt.chartInfo["edate"].substring(4,6),10);
	var dd2      = mygantt.chartInfo["edate"].substring(6,8);
	var dateObj2 = mygantt.addDay(yyyy2,mm2,dd2, 7);
	mygantt.chartInfo["edate"] = mygantt.getDateText(dateObj2);

	mygantt.dateAll      = mygantt.getCalDates();
	mygantt.calSdateObj  = null;
	mygantt.rewriteChart();
};


/**
 * ヘッダを追加する
 */
mygantt.addHeader = function(){

	var recordInfo = mygantt.recordInfo;
	var tbody = mygantt.taskTbodyObj;

	// 行の作成
	var tr    = document.createElement("tr");

	// レコードセレクタ用のヘッダ追加
	var selector = document.createElement("th");
	selector.className = "mygantt_selector";
	tr.appendChild(selector);

	var i = 0;
	var calenderTH = null;
	var headerTR = [tr];
	var preColspan = 1;
	for (i in recordInfo) {
		var colSpan = 1;
		if (mygantt.isCalenderArea(i)){
			calenderTH = document.createElement("th");
		} else {
			var headerTitle = (recordInfo[i]["title"]) ? recordInfo[i]["title"] : "";
			var rowNo       = (recordInfo[i]["rowno"]) ? parseInt(recordInfo[i]["rowno"],10) : 1;
			var rowIdx = rowNo - 1;
			if (!headerTR[rowIdx]) {
				headerTR[rowIdx] = document.createElement("tr");
			}

			if (recordInfo[i]["colspan"]) {
				colSpan = recordInfo[i]["colspan"];
			}

			if ((headerTitle != "")&&(preColspan == 1)) {
				var headerTH = document.createElement("th");
				if (recordInfo[i]["rowspan"]) {
					headerTH.rowSpan = recordInfo[i]["rowspan"];
				}
				if (recordInfo[i]["colspan"]) {
					headerTH.colSpan = recordInfo[i]["colspan"];
					headerTH.setAttribute("colSpan", recordInfo[i]["colspan"]);
				} else {
					headerTH.className = "mygantt_col" + i;
				}
				headerTH.innerHTML = headerTitle;
				headerTR[rowIdx].appendChild(headerTH);
			}
		}
		preColspan = colSpan;
	}

	// カレンダの追加
	if (calenderTH == null) calenderTH = document.createElement("th");
	mygantt.addCalender(calenderTH);
	calenderTH.style.padding = "0px";
	calenderTH.style.margin  = "0px";
	headerTR[0].appendChild(calenderTH);

	selector.rowSpan = headerTR.length;
	calenderTH.rowSpan = headerTR.length;

	// 行の追加
	for (i in headerTR) {
		headerTR[i].className = "mygantt_header";
		tbody.appendChild(headerTR[i]);
	}
};


/**
 * 明細エリアの追加
 */
mygantt.addDetail = function(){

	var i = 0;
	for (i in mygantt.chartData) {
		mygantt.addTaskData(i, mygantt.chartData[i]);
	}
};


/**
 * 明細行の追加
 */
mygantt.addTaskData = function(i, cols) {

	// テーブルbodyを取得
	var tbody = mygantt.taskTbodyObj;

	// 行の作成
	var tr       = document.createElement("tr");
	tr.id        = "mygantt_detail" + i;

	// レコードセレクタの追加
	var selector = document.createElement("td");
	selector.id  = "mygantt_selector" + i;
	selector.className = "mygantt_selector";
	selector.onclick       = function () { mygantt.selectorOnClick(i) };
	selector.oncontextmenu = function () { return mygantt.selectorOnContextmenu(i); }
	tr.appendChild(selector);

	// 列の追加
	var detailTR = [tr];

	var calTd = null;
	var colSpan = 1;
	var j = 0;
	for (j in cols) {

			var td = null;
			var inputType = (mygantt.recordInfo[j]["itype"]) ? mygantt.recordInfo[j]["itype"] : "";
			var rowNo       = (mygantt.recordInfo[j]["rowno"]) ? parseInt(mygantt.recordInfo[j]["rowno"],10) : 1;
			var rowIdx = rowNo - 1;

			// 行の作成
			if (!detailTR[rowIdx]) {
				detailTR[rowIdx] = document.createElement("tr");
			}

			if (mygantt.isCalenderArea(j)){

				// タスクバーの作成
				td = document.createElement("td");
				calTd = td;

			} else if (inputType.match(/^select/)) {

				// プルダウンの作成
				var optionValues = inputType.replace(/^select\(/,"");
				optionValues = optionValues.replace(/\)$/,"");
				var optionValueAry = optionValues.split(",");
				var k = 0;
				var texts = [];
				var values  = [];
				for (k in optionValueAry) {
					var optVal = optionValueAry[k].split(":");
					var optIdx = texts.length;
					values[optIdx]  = optVal[0];
					texts[optIdx] = (optVal.length > 1) ? optVal[1] : optVal[0];
				}

				td = document.createElement("td");
				var progressObj = document.createElement("select");
				progressObj.id = "";
				progressObj.className = "mygantt_col" + j;
				for (k = 0; k < values.length; k++) {
					progressObj.options[k] = new Option(texts[k], values[k]);
				}
				progressObj.value = parseInt(cols[j],10);
				progressObj.onchange = new Function("mygantt.chgChartData(" + i + "," + j +",this)");

				td.appendChild(progressObj);

			} else if (mygantt.recordInfo[j]["title"]) {

				// ラベルの作成
				td = document.createElement("td");
				var textObj = document.createElement("div");
				textObj.id = "task" + i + "_" + mygantt.recordInfo[j]["name"];

				textObj.innerHTML = cols[j];
				if (cols[j] == ""){
					textObj.innerHTML = mygantt.blankMark;
				}
				if (inputType != "") {
					textObj.style.cursor = "pointer";
					textObj.onclick = new Function( "mygantt.dispChgDataBox(this," + i +"," + j + ")" );
				}
				td.appendChild(textObj);
			}

			if (td){
				if (mygantt.recordInfo[j]["rowspan"]) {
					td.rowSpan = mygantt.recordInfo[j]["rowspan"];
				}
				if (mygantt.recordInfo[j]["colspan"]) {
					colSpan = mygantt.recordInfo[j]["colspan"];
//					td.colSpan = mygantt.recordInfo[j]["colspan"];
				}
				td.className = "mygantt_col" + j;
				detailTR[rowIdx].appendChild(td);
			}
	}

	// タスクバー描画用のセルを作成
	if (!calTd) {
		calTd = document.createElement("td");
		calTd.className = "mygantt_col" + (parseInt(j,10) + 1);
		detailTR[0].appendChild(calTd)
	}
	calTd.style.padding = "0px";
	calTd.className = calTd.className + " ruler" + mygantt.chartInfo["mwidth"];

	calTd.rowSpan = detailTR.length;
	selector.rowSpan = detailTR.length

	// タスクバー(予定)の作成、追加
	var objTaskArea1 = mygantt.createTaskBar(cols, i, "mygantt_taskbar", "ssdate", "sedate");
	calTd.appendChild(objTaskArea1);

	// タスクバー(実績)の作成、追加
	if (mygantt.chartInfo["type"] == "B") {
		var objTaskArea2 = mygantt.createTaskBar(cols, i, "mygantt_jissekibar", "rsdate", "redate");
		calTd.appendChild(objTaskArea2);
	}

	// 行の追加
	for (j in detailTR) {
		if (j == 0) {
			detailTR[j].id = "mygantt_detail" + i;
		} else {
			detailTR[j].id = "mygantt_detail" + i + "_" + j;
		}
		detailTR[j].className = "mygantt_detail";
		tbody.appendChild(detailTR[j]);
	}
};

/**
 * タスクバーの作成
 */
mygantt.createTaskBar = function(cols, i, className, sdateType , edateType){

	// タスクバーの描画に必要な情報を取得
	var sDate    = mygantt.getColData(cols, sdateType);
	var eDate    = mygantt.getColData(cols, edateType);
	var leftPos   = mygantt.getTaskLeft(sDate);
	var taskW     = mygantt.getTaskWidth(sDate, eDate);

	// タスクエリアを描画
	var objTaskArea = document.createElement("div");
	objTaskArea.className = className + "_area";
	objTaskArea.onselectstart   = function() { return false; };
	var widthDiv = mygantt.chartInfo["mwidth"] * mygantt.dateAll.length;
	objTaskArea.style.width = widthDiv + "px";
	objTaskArea.style.overflow = "hidden";
	objTaskArea.id = "taskArea" + i;
	var objTask = document.createElement("div");
	objTask.id = "task_" + className + i;
	objTask.className = className;
	objTask.style.position = "relative";
	objTask.style.left  = leftPos + "px";
	objTask.style.width = taskW + "px";
	objTask.onmousedown = function() { mygantt.mDown(this, sdateType, edateType) };
	objTask.onmouseout  = mygantt.mOut;
	objTask.onmouseup   = mygantt.mOut;
	objTaskArea.appendChild(objTask);

	// サイズ変更用オブジェクトを作成
	var chgSizeObj = document.createElement("div");
	objTask.style.styleFloat = "left";
	objTask.style.cssFloat   = "left";
	chgSizeObj.id = objTask.id + "R";
	chgSizeObj.style.styleFloat = "left";
	chgSizeObj.style.cssFloat   = "left";
	chgSizeObj.innerHTML = "&nbsp;";
	chgSizeObj.style.width = "20px";
	chgSizeObj.style.position = "relative";
	chgSizeObj.style.left = (leftPos - 8) + "px";
	chgSizeObj.style.top = "0px";
	chgSizeObj.onmouseover = mygantt.rOver;
	chgSizeObj.onmousedown = function () { mygantt.rDown(this, sdateType, edateType) };
	chgSizeObj.onmouseout  = mygantt.rOut;
	chgSizeObj.onmouseup   = mygantt.rUp;
	chgSizeObj.onmousemove = mygantt.rMove;
	objTaskArea.appendChild(chgSizeObj);
	return objTaskArea;
};


/**
 * データ変更用テキストBOXを追加する
 */
mygantt.addChgDataBox = function() {
	mygantt.objChgDataBox = document.createElement("input");
	mygantt.objChgDataBox.type = "text";
	mygantt.objChgDataBox.style.position = "absolute";
	mygantt.objChgDataBox.style.display = "none";
	mygantt.objChgDataBox.id = "mygantt_chgdatabox";
	mygantt.chartAreaObj.appendChild(mygantt.objChgDataBox);
};

/**
 * 値変更用のテキストBOXの表示
 */
mygantt.dispChgDataBox = function(obj, rowIdx, colIdx){
	var x = mygantt.getPosLeft(obj);
	var y = mygantt.getPosTop(obj);
	var colValue = mygantt.chartData[rowIdx][colIdx];
	if (mygantt.recordInfo[colIdx]["itype"] == "datepicker") {
		$("#mygantt_chgdatabox").datepicker($.datepicker.regional['ja']);
		$('#mygantt_chgdatabox').datepicker('option', 'duration', 'fast');
		if ((!colValue)||(colValue=="")){
			var defDateY = mygantt.chartInfo["sdate"].substring(0,4);
			var defDateM = mygantt.chartInfo["sdate"].substring(4,6);
			var defDateD = mygantt.chartInfo["sdate"].substring(6,8);
			var defDateYMD = defDateY + "/" + defDateM + "/" + defDateD;
			$('#mygantt_chgdatabox').datepicker('option', 'defaultDate', defDateYMD);
		}
	} else {
		$("#mygantt_chgdatabox").datepicker('destroy');
	}
	mygantt.objChgData = obj;
	mygantt.objChgDataBox.style.left = (x-2) + "px";
	mygantt.objChgDataBox.style.top  = (y-4) + "px";
	mygantt.objChgDataBox.value = colValue;
	mygantt.objChgDataBox.onchange = new Function("mygantt.chgChartData("+rowIdx+","+colIdx+",mygantt.objChgDataBox)");
	mygantt.objChgDataBox.onblur   = function() { mygantt.objChgDataBox.style.display = "none" };
	mygantt.objChgDataBox.style.display = "block";
	mygantt.objChgDataBox.focus();
};

/**
 * 値の変更
 */
mygantt.chgChartData = function(rowIdx, colIdx, obj){

	var colName  = mygantt.recordInfo[colIdx]["name"];
	var colValue = obj.value;

	var errFlg = false;

/*
	if (colName.match(/.*date$/)){
		try {
			var yyyy = parseInt(colValue.substring(0,4),10);
			var mm   = parseInt(colValue.substring(4,6),10) - 1;
			var dd   = colValue.substring(6,8);
			var objDate = new Date(yyyy , mm, dd);
			if ((objDate == "Invalid Date")||(objDate == "NaN")) {
				errFlg = true;
			}
		} catch (e){
			errFlg = true;
		}
	}
*/

	if (errFlg) {
		if (mygantt.objChgDataBox.style.display == "block") {
			mygantt.objChgDataBox.focus();
		}
	} else {
		mygantt.chartData[rowIdx][colIdx] = colValue;
		if (mygantt.objChgData != null) {
			colValue = mygantt.escapeHtml(colValue);
			colValue = (colValue != "") ? colValue : mygantt.blankMark;
			mygantt.objChgData.innerHTML = colValue;
			mygantt.objChgDataBox.style.display = "none";
		}
		mygantt.objChgData = null;
		if ((mygantt.recordInfo[colIdx]["ftype"] == "ssdate") 
		||  (mygantt.recordInfo[colIdx]["ftype"] == "sedate") 
		||  (mygantt.recordInfo[colIdx]["ftype"] == "rsdate") 
		||  (mygantt.recordInfo[colIdx]["ftype"] == "redate")) {
			// TODO タスクバー部分のみ変更するように
			mygantt.rewriteChart();
		}
	}
};


/**
 * レコードセレクタのクリック時
 */
mygantt.selectorOnClick = function(i){

	// 前に選択されていた行の色を戻す
	if (mygantt.selectIdx >= 0) {
		var preRec = document.getElementById("mygantt_detail" + mygantt.selectIdx);
		preRec.className = "mygantt_detail";
		var subIdx = 1;
		while (true) {
			var subRow = document.getElementById("mygantt_detail" + mygantt.selectIdx + "_" + subIdx);
			if (!subRow) break;
			subRow.className = "mygantt_detail";
			subIdx = subIdx + 1;
		}
	}

	// 選択行の色を変更
	var selectRec = document.getElementById("mygantt_detail" + i);
	if (i == mygantt.selectIdx) {
		mygantt.selectIdx = -1;
		selectRec.className = "mygantt_detail";
	} else {
		mygantt.selectIdx = i;
		selectRec.className = "mygantt_detail_select";
	}

	// 副行がある場合はそちらも色変更
	var subIdx = 1;
	while (true) {
		var subRow = document.getElementById("mygantt_detail" + i + "_" + subIdx);
		if (!subRow) break;
		subRow.className = selectRec.className;
		subIdx = subIdx + 1;
	}

};


/**
 * レコードセレクタの右クリック時
 */
mygantt.selectorOnContextmenu = function(i){

	if (i == mygantt.selectIdx) {
		mygantt.selectIdx = -1;
	}
	mygantt.selectorOnClick(i);

	// 右クリックメニュ－の表示
	mygantt.dispRecordMenu();

	return false;
};

/**
 * 右クリックメニューの表示
 */
mygantt.dispRecordMenu = function() {
	
	var x = event.clientX;
	var y = event.clientY;
	mygantt.contextMenu.style.display = "block";
	mygantt.contextMenu.style.left = x + "px";
	mygantt.contextMenu.style.top  = y + "px";
}

/**
 * 右クリックメニューの登録
 */
mygantt.addContextMenu = function() {

	mygantt.contextMenu = document.createElement("div");
	mygantt.contextMenu.id = "mygantt_contextmenu";

	var i = 0;
	for (i in mygantt.contextMenuInfo) {
		if (mygantt.contextMenuInfo[i] == null){
			var separator = document.createElement("hr");
			mygantt.contextMenu.appendChild(separator);
		} else {
			var menu = document.createElement("a");
			menu.href = "#";
			menu.onclick      = new Function( mygantt.contextMenuInfo[i][1] );
			menu.innerHTML    = mygantt.contextMenuInfo[i][0];
			mygantt.contextMenu.appendChild(menu);
		}
	}

	mygantt.chartAreaObj.appendChild(mygantt.contextMenu);
}


/**
 * 行の横幅を取得する
 */
mygantt.getRowW = function(){
	return (mygantt.dateAll.length * mygantt.chartInfo.mwidth);
};


/**
 * 指定された列番号がタスクバーエリアのものかどうか判定する
 */
mygantt.isCalenderArea = function(idx){
	return (mygantt.recordInfo[idx]["ftype"] == "calender");
};

/**
 * 指定された列番号が開始予定日のものかどうか判定する
 */
mygantt.isSSDate = function(idx){
	return (mygantt.recordInfo[idx]["ftype"] == "ssdate");
};

/**
 * 指定された列番号が終了予定日のものかどうか判定する
 */
mygantt.isSEDate = function(idx){
	return (mygantt.recordInfo[idx]["ftype"] == "sedate");
};

/**
 * 指定された列番号が開始実績日のものかどうか判定する
 */
mygantt.isRSDate = function(idx){
	return (mygantt.recordInfo[idx]["ftype"] == "rsdate");
};

/**
 * 指定された列番号が終了実績日のものかどうか判定する
 */
mygantt.isREDate = function(idx){
	return (mygantt.recordInfo[idx]["ftype"] == "redate");
};


/**
 * 列のデータを取得する
 */
mygantt.getColData = function(cols, colName){

	var i = 0;
	for (i in mygantt.recordInfo) {
		if (mygantt.recordInfo[i]["ftype"] == colName){
			return cols[i];
		}
	}
	return "";
};

/**
 * 列のデータを設定する
 */
mygantt.setColData = function(cols, colName, data){

	var i = 0;
	for (i in mygantt.recordInfo) {
		if (mygantt.recordInfo[i]["ftype"] == colName){
			cols[i] = data;
		}
	}
};


/**
 * レコードを上に移動する
 */
mygantt.recordUp = function() {
	if (mygantt.selectIdx <= 0) {
		alert("移動できません");
	} else {
		var moveIdx = parseInt(mygantt.selectIdx,10) - 1;
		var tmpRec = mygantt.chartData[moveIdx];
		mygantt.chartData[moveIdx] = mygantt.chartData[mygantt.selectIdx];
		mygantt.chartData[mygantt.selectIdx] = tmpRec;
		mygantt.rewriteChart();           // 再描画
		mygantt.selectorOnClick(moveIdx); // 再選択
	}
}

/**
 * レコードを下に移動する
 */
mygantt.recordDown = function() {
	if (mygantt.selectIdx >= (mygantt.chartData.length - 1)) {
		alert("移動できません");
	} else {
		var moveIdx = parseInt(mygantt.selectIdx,10) + 1;
		var tmpRec = mygantt.chartData[moveIdx];
		mygantt.chartData[moveIdx] = mygantt.chartData[mygantt.selectIdx];
		mygantt.chartData[mygantt.selectIdx] = tmpRec;
		mygantt.rewriteChart();           // 再描画
		mygantt.selectorOnClick(moveIdx); // 再選択
	}
}

/**
 * レコードを削除する
 */
mygantt.recordDel = function() {

	var newChartData = [];
	var i = 0;
	for (i in mygantt.chartData) {
		if (i != mygantt.selectIdx) {
			newChartData[newChartData.length] = mygantt.chartData[i];
		}
	}
	mygantt.selectIdx = -1;
	mygantt.chartData = newChartData;
	mygantt.rewriteChart();           // 再描画
}


/**
 * レコードを上に追加する
 */
mygantt.recordAddOver = function() {

	var newChartData = [];
	var i = 0;
	var addIdx = parseInt(mygantt.selectIdx,10);
	for (i in mygantt.chartData) {
		if (i == addIdx) {
			var newRecord = [];
			var j = 0;
			for (j in mygantt.recordInfo){
				newRecord[j] = "";
			}
			newChartData[newChartData.length] = newRecord;
		}
		newChartData[newChartData.length] = mygantt.chartData[i];
	}
	mygantt.selectIdx = -1;
	mygantt.chartData = newChartData;
	mygantt.rewriteChart();           // 再描画
}

/**
 * レコードを下に追加する
 */
mygantt.recordAddUnder = function() {

	var newChartData = [];
	var i = 0;
	var addIdx = parseInt(mygantt.selectIdx,10) + 1;
	for (i in mygantt.chartData) {
		if (i == addIdx) {
			var newRecord = [];
			var j = 0;
			for (j in mygantt.recordInfo){
				newRecord[j] = "";
			}
			newChartData[newChartData.length] = newRecord;
		}
		newChartData[newChartData.length] = mygantt.chartData[i];
	}
	mygantt.selectIdx = -1;
	mygantt.chartData = newChartData;
	mygantt.rewriteChart();           // 再描画
}

/**
 * レコードを一番下に追加する
 */
mygantt.recordAdd = function() {
	var newRecord = [];
	var j = 0;
	for (j in mygantt.recordInfo){
		newRecord[j] = "";
	}
	mygantt.chartData[mygantt.chartData.length] = newRecord;
//	mygantt.selectIdx = -1;
	mygantt.rewriteChart();           // 再描画
};

/**
 * データをsubmitする
 */
mygantt.submit = function(attributes){

	// フォームを作成
	var formObj = document.getElementById("mygantt_form");
	if (!formObj) {
		formObj = document.createElement("form");
		formObj.style.display = "none";
		mygantt.chartAreaObj.appendChild(formObj);
	}

	// フォームの子要素をいったん削除
	while(formObj.firstChild){
		mygantt.chartAreaObj.removeChild(formObj.firstChild);
	}

	// フォーム要素を追加
	var i = 0;
	for (i in mygantt.chartData) {
		var rec = mygantt.chartData[i];
		var j = 0;
		for (j in mygantt.recordInfo) {
			if (mygantt.recordInfo[j]["name"]) {
				var colName = mygantt.recordInfo[j]["name"];
				if ((mygantt.chartInfo["recPrefix"])&&(mygantt.chartInfo["recPrefix"]!="")) {
					colName = mygantt.chartInfo["recPrefix"] + "["+i+"]." + colName;
				} else {
					colName = colName + "["+i+"]";
				}
				var inputText = document.createElement("input");
				inputText.type = "text";
				inputText.name  = colName;
				inputText.value = rec[j];
				formObj.appendChild(inputText)
			}
		}
	}

	// フォーム属性の設定
	if (attributes){
		var attName = "";
		for (attName in attributes){
			formObj.setAttribute(attName, attributes[attName]);
		}
	}

	// actionに含まれる引数の取得＆post要素への変換
	var actionPath = formObj.action;
	var actionAry = actionPath.split("?");
	if (actionAry[1]) {
		formObj.action = actionAry[0];
		var args = actionAry[1].split("&");
		for (i in args){
			var keyVal = args[i].split("=");
			var argObj   = document.createElement("input");
			argObj.type  = "text";
			argObj.name  = keyVal[0];
			argObj.value = (keyVal.length > 1) ? keyVal[1] : "";
			formObj.appendChild(argObj);
		}
	}

	// フォーム内容を送信
	formObj.submit();
}


/**
 * タスクバーの左位置を取得する
 */
mygantt.getTaskLeft = function(ssDate){

	if ((ssDate == null)||(ssDate == "")) {
		return 0;
	}

	var calSdate = mygantt.chartInfo["sdate"];
	if (mygantt.calSdateObj == null) {
		var yyyy = mygantt.getYear(calSdate);
		var mm   = mygantt.getMonth(calSdate);
		var dd   = mygantt.getDay(calSdate);
		mygantt.calSdateObj = new Date(yyyy , mm - 1, dd);
	}
	var yyyy = mygantt.getYear(ssDate);
	var mm   = mygantt.getMonth(ssDate);
	var dd   = mygantt.getDay(ssDate);
	var sdateObj = new Date(yyyy , mm - 1, dd);
	var dateRange = (sdateObj - mygantt.calSdateObj) / (60*60*24*1000);
	return dateRange * mygantt.chartInfo["mwidth"];
};

/**
 * タスクバーの幅を取得する
 */
mygantt.getTaskWidth = function(sdate, edate){

	if ((sdate == null)||(sdate == "")||(edate == null)||(edate == "")) {
		return 0;
	}
	if (sdate > edate) {
		return 0;
	}

	var yyyy1 = mygantt.getYear(sdate);
	var mm1   = mygantt.getMonth(sdate);
	var dd1   = mygantt.getDay(sdate);
	var sdateObj = new Date(yyyy1 , mm1 - 1, dd1);

	var yyyy2 = mygantt.getYear(edate);
	var mm2   = mygantt.getMonth(edate);
	var dd2   = mygantt.getDay(edate);

	var edateObj = new Date(yyyy2 , mm2 - 1, dd2);
	var dateRange = (edateObj - sdateObj) / (60*60*24*1000);
	var taskW = (dateRange * mygantt.chartInfo["mwidth"]) + mygantt.chartInfo["mwidth"];
	return taskW;
};

/**
 * カレンダの追加
 */
mygantt.addCalender = function(calArea){

	var isHeader = true;
	if (arguments.length > 1) {
		isHeader = arguments[1];
	}

	var dateAll = mygantt.dateAll;

	var blockW  = mygantt.chartInfo.mwidth;
	var dateCnt = dateAll.length;

	var table = document.createElement("table");
	table.className = "mygantt_table";
	var tbody = document.createElement("tbody");
	var trYM  = document.createElement("tr");
	var trDD  = document.createElement("tr");

	trYM.className = "ym";
	trDD.className = "dd";

	var i = 0;
	var preYm = "";
	var preYmTH = null;
	var preDdTD = null;
	var monthOfDay = 0;
	var youbi = new Date(dateAll[0]).getDay() - 1;
	var youbiJpn = mygantt.youbiText;
	for (i = 0; i < dateCnt; i++) {
		var ymd = dateAll[i];
		var ymdAry = ymd.split("/");
		var ym   = ymdAry[0] + mygantt.yearJpn + ymdAry[1] + mygantt.monthJpn;
		var mm   = ymdAry[1];
		var dd   = ymdAry[2];
		var yyyymmdd = ymdAry[0] + ((ymdAry[1].length<2) ? "0"+ymdAry[1]: ymdAry[1]) + ((ymdAry[2].length<2) ? "0"+ymdAry[2]: ymdAry[2]);
		youbi = (youbi == 6) ? 0 : (youbi + 1);
		if (ym != preYm) {
			if (preYmTH != null) {
				preYmTH.colSpan = monthOfDay;
				preDdTD.className = "last";
			}
			var thYM = document.createElement("th");
//			thYM.className = "ym";
			thYM.innerHTML = ym;
			trYM.appendChild(thYM);
			preYm = ym;
			preYmTH = thYM;
			monthOfDay = 0;
		}
		var tdDD = document.createElement("td");
		preDdTD = tdDD;
		if (isHeader) {
			var youbiClass = "youbi" + youbi;
			if (mygantt.holidayMap[yyyymmdd] == yyyymmdd ){
				youbiClass = 'youbi0';
			}
			tdDD.innerHTML = "<span class='"+youbiClass+"'>" + dd + '</span>';
			if (mygantt.youbiText.length > 0) {
				tdDD.innerHTML = "<span class='"+youbiClass+"'>" + dd + '<br />' +'(' + youbiJpn[youbi] +')</span>';
			}
		} else {
			tdDD.innerHTML = "&nbsp;";
		}
		tdDD.style.width = (blockW -1) + "px";
		trDD.appendChild(tdDD);
		monthOfDay = monthOfDay + 1;
	}

	if (preYmTH != null) {
		preYmTH.colSpan = monthOfDay;
		preYmTH.className = "last";
	}

	if (isHeader) {
		tbody.appendChild(trYM);
	}
	tbody.appendChild(trDD);
	table.appendChild(tbody);
	table.style.width = (blockW * dateCnt) + "px";
	calArea.appendChild(table);
};

/**
 * カレンダ情報取得
 */
mygantt.getCalDates = function(){

	var sdate = mygantt.chartInfo["sdate"];
	var edate = mygantt.chartInfo["edate"];

	var yyyy1 = parseInt(sdate.substring(0,4),10);
	var mm1   = parseInt(sdate.substring(4,6),10) - 1;
	var dd1   = sdate.substring(6,8);
	var sdateObj = new Date(yyyy1 , mm1, dd1);
	var time1 = sdateObj.getTime();

	var yyyy2 = parseInt(edate.substring(0,4),10);
	var mm2   = parseInt(edate.substring(4,6),10) - 1;
	var dd2   = edate.substring(6,8);
	var edateObj = new Date(yyyy2 , mm2, dd2);
	var time2 = edateObj.getTime();

	var dateAry = [];
	while (true){
		if ((time2 - time1) < 0) break;
		var yyyy = sdateObj.getFullYear();
		var mm   = sdateObj.getMonth() + 1;
		var dd   = sdateObj.getDate();
		dateAry[dateAry.length] = yyyy + "/" + mm + "/" + dd;
		time1 = time1 + (60*60*24*1000);
		sdateObj.setTime(time1);
	}
	return dateAry;
};

/**
 * タスクバーをクリック時の処理
 */
mygantt.mDown = function(obj, sdateType, edateType){
	mygantt.mObj = obj;
	mygantt.mPreX = parseInt(event.clientX, 10);
	mygantt.mObjSdateType = sdateType;
	mygantt.mObjEdateType = edateType;
};

/**
 * タスクバーを移動時の処理
 */
mygantt.mMove = function(){
	var evt = (arguments[0]) ? arguments[0] : event;
	var nowX = parseInt(evt.clientX,10);
	if (mygantt.mObj != null){
		var moveX = nowX - mygantt.mPreX;
		var chgX = parseInt(mygantt.mObj.style.left) + moveX;
		mygantt.mPreX = nowX;
		mygantt.mObj.style.left = chgX + "px";
		document.getElementById(mygantt.mObj.id + "R").style.left = (chgX - 8) + "px";
	}
};

/**
 * タスクバーからマウスアウト時の処理
 */
mygantt.mOut = function(){

	if (mygantt.mObj != null){
		var moveRange = (mygantt.chartInfo["mwidth"] * mygantt.chartInfo["mmove"]);
		var nowX = parseInt(mygantt.mObj.style.left,10);              // 今の座標
		var chgX = Math.floor(nowX / moveRange) * moveRange;  // メモリサイズ単位に補正
		var chgW = parseInt(mygantt.mObj.style.width,10);
		var mod  = (nowX / moveRange) - Math.floor(nowX / moveRange); 
		chgX = (mod > 0.5) ? (chgX + moveRange) : chgX;       // メモリの半分以上の変更かどうかで補正値を修正
//		chgX = (chgX < 0) ? 0 : chgX;                         // 0以下の場合は0に変更
		mygantt.mObj.style.left = chgX + "px";                        // 移動
		document.getElementById(mygantt.mObj.id + "R").style.left = (chgX - 8) + "px";

		// データ変更準備
		var idx  = parseInt((mygantt.mObj.id).replace(/[a-zA-Z_]/g,""),10);
		var startPos = (chgX / mygantt.chartInfo["mwidth"]);
		var endPos   = startPos + (chgW / mygantt.chartInfo["mwidth"]) - 1;
		var sdateObj = mygantt.addDayFromText(mygantt.chartInfo["sdate"], startPos);
		var edateObj = mygantt.addDayFromText(mygantt.chartInfo["sdate"], endPos);
		var sdateType = mygantt.mObjSdateType;
		var edateType = mygantt.mObjEdateType;
		var sdateId = "";
		var edateId = "";
		for (i in mygantt.recordInfo){
			var ftype = mygantt.recordInfo[i]["ftype"];
			if (sdateType == ftype){
				sdateId = mygantt.recordInfo[i]["name"];
			}
			if (edateType == ftype){
				edateId = mygantt.recordInfo[i]["name"];
			}
		}

		// 開始日の変更
		var sdateLabel = document.getElementById("task"+idx+"_"+sdateId);
		if (sdateLabel) {
			var sdateText = mygantt.getDateText(sdateObj, "/");
			sdateLabel.innerHTML = sdateText;
			mygantt.setColData(mygantt.chartData[idx], sdateType, sdateText);
		}

		// 終了日の変更
		var edateLabel = document.getElementById("task"+idx+"_"+edateId);
		if (edateLabel) {
			var edateText = mygantt.getDateText(edateObj, "/");
			edateLabel.innerHTML = edateText;
			mygantt.setColData(mygantt.chartData[idx], edateType, edateText);
		}
	}
	mygantt.mObj = null;
};

/**
 * サイズ変更用オブジェクトクリック時
 */
mygantt.rDown = function(obj, sdateType, edateType){
	var targetId = (obj.id).replace("R","");
	mygantt.rObj = document.getElementById(targetId);
	mygantt.rPreX = parseInt(event.clientX,10);
	mygantt.rObjSdateType = sdateType;
	mygantt.rObjEdateType = edateType;
};

/**
 * サイズ変更用オブジェクトにマウスオーバー時
 */
mygantt.rOver = function(){
	document.body.style.cursor = "e-resize";
};

/**
 * サイズ変更用オブジェクトのマウスアップ時
 */
mygantt.rUp = function(){
	if (mygantt.rObj != null){
		var moveRange = (mygantt.chartInfo["mwidth"] * mygantt.chartInfo["mmove"]);
		var nowW = parseInt(mygantt.rObj.style.width, 10);
		var chgW = Math.floor(nowW / moveRange) * moveRange;         // メモリサイズ単位に補正(切捨て)
		var mod = (nowW / moveRange) - Math.floor(nowW / moveRange); 
		chgW = (mod > 0.5) ? (chgW + moveRange) : chgW;              // メモリの半分以上の変更かどうかで補正値を修正
		mygantt.rObj.style.width = chgW + "px";                      // 幅変更

		var chgX = parseInt(mygantt.rObj.style.left,10);

		// データ変更準備
		var idx  = parseInt((mygantt.rObj.id).replace(/[a-zA-Z_]/g,""),10);
		var startPos = (chgX / mygantt.chartInfo["mwidth"]);
		var endPos   = startPos + (chgW / mygantt.chartInfo["mwidth"]) - 1;
		var sdateObj = mygantt.addDayFromText(mygantt.chartInfo["sdate"], startPos);
		var edateObj = mygantt.addDayFromText(mygantt.chartInfo["sdate"], endPos);
		var sdateType = mygantt.rObjSdateType;
		var edateType = mygantt.rObjEdateType;
		var sdateId = "";
		var edateId = "";
		for (i in mygantt.recordInfo){
			var ftype = mygantt.recordInfo[i]["ftype"];
			if (sdateType == ftype){
				sdateId = mygantt.recordInfo[i]["name"];
			}
			if (edateType == ftype){
				edateId = mygantt.recordInfo[i]["name"];
			}
		}

		// 開始日の変更
		var sdateLabel = document.getElementById("task"+idx+"_"+sdateId);
		if (sdateLabel) {
			var sdateText = mygantt.getDateText(sdateObj, "/");
			sdateLabel.innerHTML = sdateText;
			mygantt.setColData(mygantt.chartData[idx], sdateType, sdateText);
		}

		// 終了日の変更
		var edateLabel = document.getElementById("task"+idx+"_"+edateId);
		if (edateLabel) {
			var edateText = mygantt.getDateText(edateObj, "/");
			edateLabel.innerHTML = edateText;
			mygantt.setColData(mygantt.chartData[idx], edateType, edateText);
		}
	}
	mygantt.rObj = null;
};

/**
 * サイズ変更用オブジェクトのマウスアウト時
 */
mygantt.rOut = function(){
	mygantt.rUp();
	document.body.style.cursor = "default";
};


/**
 * サイズ変更用オブジェクトのマウス移動時
 */
mygantt.rMove = function(){
	var evt = (arguments[0]) ? arguments[0] : event;
	var nowX = parseInt(evt.clientX,10);
	if (mygantt.rObj != null) {
		var w = nowX - mygantt.rPreX;
		var chgW = parseInt(mygantt.rObj.style.width) + w;
		mygantt.rPreX = nowX;
		mygantt.rObj.style.width = chgW + "px";
	}
};


/**
 * HTML文字列のエスケープ
 */
mygantt.escapeHtml = function(text){
	text = text.replace("&","&amp;");
	text = text.replace("<","&lt;");
	text = text.replace(">","&gt;");
	text = text.replace(" ","&nbsp;");
	return text;
};

/**
 * オブジェクトのY座標を取得する
 */
mygantt.getPosTop = function(obj){
	topPos = 0;
	while (true){
		topPos = topPos + obj.offsetTop;
		if (obj.offsetParent) {
			obj = obj.offsetParent;
		} else {
			break;
		}
	}
	return topPos;
};

/**
 * オブジェクトのX座標を取得する
 */
mygantt.getPosLeft = function(obj){
	leftPos = 0;
	while (true){
		leftPos = leftPos + obj.offsetLeft;
		if (obj.offsetParent) {
			obj = obj.offsetParent;
		} else {
			break;
		}
	}
	return leftPos;
};


/**
 * n日後,n日前の日付を求める
 */
mygantt.addDay = function(year, month, day, addDays) {
	var dateObj = new Date(year, month - 1, day);
	var baseSec = dateObj.getTime();
	var addSec = addDays * 86400000;
	var targetSec = baseSec + addSec;
	dateObj.setTime(targetSec);
	return dateObj;
};

/**
 * n日後,n日前の日付を求める
 */
mygantt.addDayFromText = function(dateText, addDays) {

	var yyyy = mygantt.getYear(dateText);
	var mm   = mygantt.getMonth(dateText);
	var dd   = mygantt.getDay(dateText);

	var dateObj = new Date(yyyy, mm - 1, dd);
	var baseSec = dateObj.getTime();
	var addSec = addDays * 86400000;
	var targetSec = baseSec + addSec;
	dateObj.setTime(targetSec);
	return dateObj;
};


/**
 * 日付を文字列で取得する
 */
mygantt.getDateText = function(dateObj /*, delimiter */) {
	var delimiter = "";
	if (arguments.length > 1) {
		delimiter = arguments[1];
	}
	var yyyy = parseInt(dateObj.getFullYear(),10);
	var mm   = parseInt(dateObj.getMonth()+1,10);
	var dd   = parseInt(dateObj.getDate(),10);
	if (mm < 10) {
		mm = "0" + mm;
	}
	if (dd < 10) {
		dd = "0" + dd;
	}
	return yyyy + delimiter + mm + delimiter + dd;
};

/**
 * 年月日を配列で取得する
 */
mygantt.getYmdAry = function(dateText) {
	var yyyy = "";
	var mm   = "";
	var dd   = "";
	if (dateText.match(/^[0-9][0-9][0-9][0-9]\/[0-9]([0-9]|)\/[0-9]([0-9]|)$/)) {
		var dateAry = dateText.split("/");
		yyyy = parseInt(dateAry[0],10);
		mm   = parseInt(dateAry[1],10);
		dd   = parseInt(dateAry[2],10);
	} else {
		yyyy = parseInt(dateText.substring(0,4),10);
		mm   = parseInt(dateText.substring(4,6),10);
		dd   = parseInt(dateText.substring(6,8),10);
	}
	var dateAry = [ yyyy, mm, dd];
	return dateAry;
};

/**
 * 年を取得する
 */
mygantt.getYear = function(dateText) {
	var dateAry = mygantt.getYmdAry(dateText);
	return dateAry[0];
};

/**
 * 月を取得する
 */
mygantt.getMonth = function(dateText) {
	var dateAry = mygantt.getYmdAry(dateText);
	return dateAry[1];
};

/**
 * 日を取得する
 */
mygantt.getDay = function(dateText) {
	var dateAry = mygantt.getYmdAry(dateText);
	return dateAry[2];
};

/**
 * nヶ月後,nヶ月前の日付を求める
 */
mygantt.addMonth = function(year, month, day, addMonths) {
	year  = parseInt(year,10);
	month = parseInt(month,10);
	day   = parseInt(day,10);
	var nowEndDay = mygantt.getLastDayOfMonth(year, month);
	month += addMonths;
	var endDay = mygantt.getLastDayOfMonth(year, month);
	if (nowEndDay == day) {
		day = endDay;
	}
	var dateObj = new Date(year, month - 1, day);
	return dateObj;
};


/**
 * 月末日を求める
 */
mygantt.getLastDayOfMonth = function(year, month) {
	var dateObj = new Date(year, month, 0);
	return dateObj.getDate();
};

